Package org.apache.sling.testing.mock.sling.junit

# Class SlingContext

java.lang.Object
org.apache.sling.testing.mock.osgi.context.OsgiContextImpl
org.apache.sling.testing.mock.sling.context.SlingContextImpl
org.apache.sling.testing.mock.sling.junit.SlingContext

All Implemented Interfaces:
  `org.junit.rules.TestRule`

@ProviderType public final class SlingContext extends org.apache.sling.testing.mock.sling.context.SlingContextImpl implements org.junit.rules.TestRule
JUnit rule for setting up and tearing down Sling context objects for unit tests. You can use `SlingContextBuilder` alternatively to the constructors on this class - it offers more options and fine-grained control about setting up the test context.

## Field Summary

### Fields inherited from class org.apache.sling.testing.mock.sling.context.SlingContextImpl

`contentBuilder, contentLoader, contentLoaderAutoCommit, request, resourceBuilder, resourceResolver, resourceResolverFactory, resourceResolverType, response, slingScriptHelper, uniqueRoot`

### Fields inherited from class org.apache.sling.testing.mock.osgi.context.OsgiContextImpl

`componentContext`

## Constructor Summary

Constructors
Constructor
Description
`SlingContext()`
Initialize Sling context with default resource resolver type: `MockSling.DEFAULT_RESOURCERESOLVER_TYPE`.
`SlingContext(@NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<T> afterSetUpCallback)`
Initialize Sling context with default resource resolver type: `MockSling.DEFAULT_RESOURCERESOLVER_TYPE`.
`SlingContext(@NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<T> afterSetUpCallback, @NotNull org.apache.sling.testing.mock.sling.ResourceResolverType resourceResolverType)`
Initialize Sling context with resource resolver type.
`SlingContext(@NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<U> afterSetUpCallback, @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<V> beforeTearDownCallback)`
Initialize Sling context with default resource resolver type: `MockSling.DEFAULT_RESOURCERESOLVER_TYPE`.
`SlingContext(@NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<U> afterSetUpCallback, @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<V> beforeTearDownCallback, @NotNull org.apache.sling.testing.mock.sling.ResourceResolverType resourceResolverType)`
Initialize Sling context with resource resolver type.
`SlingContext(@NotNull org.apache.sling.testing.mock.sling.ResourceResolverType resourceResolverType)`
Initialize Sling context with resource resolver type.

## Method Summary

Modifier and Type
Method
Description
`org.junit.runners.model.Statement`
`apply(org.junit.runners.model.Statement base, org.junit.runner.Description description)`

### Methods inherited from class org.apache.sling.testing.mock.sling.context.SlingContextImpl

`addModelsForClasses, addModelsForClasses, addModelsForPackage, addModelsForPackage, build, create, currentResource, currentResource, currentResource, load, load, newResourceResolverFactory, registerAdapter, registerAdapter, registerDefaultServices, request, requestPathInfo, resolveSlingBindingProperty, resolveSlingBindingProperty, resourceResolver, resourceResolverType, response, runMode, setRegisterSlingModelsFromClassPath, setResourceResolverFactoryActivatorProps, setResourceResolverType, setUp, slingScriptHelper, tearDown, uniqueRoot`

### Methods inherited from class org.apache.sling.testing.mock.osgi.context.OsgiContextImpl

`bundleContext, componentContext, getService, getServices, registerInjectActivateService, registerInjectActivateService, registerInjectActivateService, registerInjectActivateService, registerInjectActivateService, registerInjectActivateService, registerService, registerService, registerService, registerService`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### SlingContext

public SlingContext()
Initialize Sling context with default resource resolver type: `MockSling.DEFAULT_RESOURCERESOLVER_TYPE`.

### SlingContext

public SlingContext(@NotNull @NotNull org.apache.sling.testing.mock.sling.ResourceResolverType resourceResolverType)
Initialize Sling context with resource resolver type.

Parameters:
  `resourceResolverType` - Resource resolver type.

### SlingContext

public SlingContext(@NotNull @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<T> afterSetUpCallback)
Initialize Sling context with default resource resolver type: `MockSling.DEFAULT_RESOURCERESOLVER_TYPE`.

Type Parameters:
  `T` - context type
Parameters:
  `afterSetUpCallback` - Allows the application to register an own callback function that is called after the built-in setup rules are executed.

### SlingContext

public SlingContext(@NotNull @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<T> afterSetUpCallback, @NotNull @NotNull org.apache.sling.testing.mock.sling.ResourceResolverType resourceResolverType)
Initialize Sling context with resource resolver type.

Type Parameters:
  `T` - context type
Parameters:
  `afterSetUpCallback` - Allows the application to register an own callback function that is called after the built-in setup rules are executed.
  `resourceResolverType` - Resource resolver type.

### SlingContext

public SlingContext(@NotNull @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<U> afterSetUpCallback, @NotNull @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<V> beforeTearDownCallback)
Initialize Sling context with default resource resolver type: `MockSling.DEFAULT_RESOURCERESOLVER_TYPE`.

Type Parameters:
  `U` - context type
  `V` - context type
Parameters:
  `afterSetUpCallback` - Allows the application to register an own callback function that is called after the built-in setup rules are executed.
  `beforeTearDownCallback` - Allows the application to register an own callback function that is called before the built-in teardown rules are executed.

### SlingContext

public SlingContext(@NotNull @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<U> afterSetUpCallback, @NotNull @NotNull org.apache.sling.testing.mock.osgi.context.ContextCallback<V> beforeTearDownCallback, @NotNull @NotNull org.apache.sling.testing.mock.sling.ResourceResolverType resourceResolverType)
Initialize Sling context with resource resolver type.

Type Parameters:
  `U` - context type
  `V` - context type
Parameters:
  `afterSetUpCallback` - Allows the application to register an own callback function that is called after the built-in setup rules are executed.
  `beforeTearDownCallback` - Allows the application to register an own callback function that is called before the built-in teardown rules are executed.
  `resourceResolverType` - Resource resolver type.

## Method Details

### apply

public org.junit.runners.model.Statement apply(org.junit.runners.model.Statement base, org.junit.runner.Description description)

Specified by:
  `apply` in interface `org.junit.rules.TestRule`